(function(window) {
  var $ = window['jQuery'];
  var AJS = window['AJS'];

  var baseUrl = window['contextPath'] || '/';
  if (baseUrl.substring(baseUrl.length - 1) !== '/') {
    baseUrl += '/';
  }

  function getDebugQueryParam() {
    if (location && location.search && location.search.match(/[?&]showJCPLWelcomeMessage=true/)) return "?debug=true";
    else return '';
  }

  $.ajax({
    url : baseUrl + 'rest/jiraclient/1.0/message' + getDebugQueryParam(),
    dataType : 'json',
    success: function(message) {
      $(function() {
        showMessage(message && message['message']);
      })
    }
  });

  function showMessage(message) {
    if (!message) return;
    var messageDiv = $('<div></div>');
    messageDiv.addClass('jcpl-welcome-message');
    messageDiv.html(message);
    messageDiv.prependTo($('body'));
    var downloadLink = messageDiv.find('.alm-jc-download-link').attr('href') || 'http://almworks.com/get-jiraclient-site';
    var infoPanel = createInfoPanel(messageDiv, downloadLink);
    messageDiv.find('a.s-dismiss')
      .click(function (e) {
        e.preventDefault();
        $.ajax({
          url:baseUrl + 'rest/jiraclient/1.0/message',
          type:'DELETE',
          dataType:'json'
        });
        messageDiv.slideUp();
        if (infoPanel) {
          infoPanel.hide();
        }
        return false;
      });
  }

  function createInfoPanel(messageDiv, downloadLink) {
    var infoHtml = ''
        + '<div class="jc-info-panel">'
          + '<p>'
          + 'JIRA Client is a desktop application that works on Windows, Mac OS X, and Linux.'
          + '</p>'

          + '<p class="header">'
          + 'Features and benefits:'
          + '</p>'
          + '<ul>'
            + '<li>Organize frequently used queries into a hierarchy.</li>'
            + '<li>Triage issues via drag-and-drop on queries.</li>'
            + '<li>Fast navigation and browsing &mdash; no waiting for the web page to load.</li>'
            + '<li>You can work offline.</li>'
            + '<li>Time tracking with Start/Stop buttons.</li>'
            + '<li>Screenshot tool to capture, edit, and attach images to issues.</li>'
            + '<li>Parallel searches in separate tabs.</li>'
            + '<li>Issue grouping with local tags.</li>'
          + '</ul>'

          + '<p>You can learn more on the <a href="http://almworks.com/jiraclient-site-jira">JIRA Client website</a>.</p>'

          + '<div class="separator"></div>'

          + '<p>'
          + 'You see this message because your JIRA is licensed for access through JIRA Client. To use JIRA Client:'
          + '</p>'
          + '<ol>'
            + '<li><a href="' + downloadLink + '">Download JIRA Client</a> from ALM Works website.</li>'
            + '<li>Install (see installation instructions on the download page.)</li>'
            + '<li>Create connection to this JIRA and specify your login and password.</li>'
            + '<li>After the connection is initialized, double-click on a predefined query to run it, or create your own query.</li>'
            + '<li class="italic">Enjoy!</li>'
          + '</ol>'
        + '</div>'
      ;

    if (AJS) {
      return AJS.InlineDialog(
        messageDiv.find('.jc-info-link'),
        'jc-info-dialog',
        function(content$, trigger, showPopup){
          content$.html(infoHtml);
          showPopup();
        },
        {
          onHover:true,
          width:800,
          hideDelay:60000
        }
      );
    }
    return null;
  }
})(window);